#!/usr/bin/env ruby
$KCODE = 'e'
#
# $Id: Ci.rb,v 1.43 2003/03/09 08:12:12 Yuukis Exp $
#
# Default configuration.

Root = "#{ENV['HOME']}/.ci/"				# cache files place

#
# Default configuration (can overwrite user config).

scriptRoot = "#{ENV['HOME']}/opt/Ci/"		# loding scripts and others directory
boardSelect = 'left'						# 'right' or 'left'
favoriteBoards = []							# ex. ['unix', 'linux', 'tech']
httpCommand = '/usr/local/bin/mozilla -remote "openurl(%d)"'
											# which your web user agent. replace "%d" as URI.
defaultName = '̵̾ at C.i.'			# default name in follow up.
defaultMailto = 'sage'						# default mail address in follow up.
bbsMenuCheck = true							# true / false BBSMenuCheck at Starting C.i.
netUpCi = false								# get release information.
threadTabWidth = 6							# Thread Tab Width.
closeOnTab = true							# true / false Close button on tab.
defaultWidth = 525							# Default window width.
defaultHeight = 450							# Default window height.
boardSelectorWidth = 300					# Board Selector width.

#
#

CiVersion = 'beta.4'
CiCode = 'TYPE-0'

require 'gtk'

Dir.mkdir(Root) unless File.exist?(Root)
BBSMenuURI = 'http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html'
MonazillaUA = "Monazilla/1.00 (C.i./#{CiVersion})"

# Load UserConfig
if File.exist?("#{Root}ci.cfg")
	userConf = IO.readlines("#{Root}ci.cfg").join
	eval(userConf)
end


# set or overwrite configuration.
# (ȤꤢեθߴݤΤˡѤʤ)
# 
$cfg = {}

$cfg['scriptRoot']= scriptRoot
$cfg['boardSelect']= boardSelect
$cfg['favoriteBoards']= favoriteBoards
$cfg['httpCommand']= httpCommand
$cfg['defaultName']= defaultName
$cfg['defaultMailto']= defaultMailto
$cfg['bbsMenuCheck']= bbsMenuCheck
$cfg['netUpCi']= netUpCi
$cfg['threadTabWidth']= threadTabWidth
$cfg['closeOnTab']= closeOnTab
$cfg['defaultWidth']= defaultWidth
$cfg['defaultHeight']= defaultHeight
$cfg['boardSelectorWidth']= boardSelectorWidth


# Load gzip
#  Thank you for 11ܤ̵̾
p = ENV['PATH'].split(':')
p.each {|path|
	if File.executable?("#{path}/gzip")
		$cfg['gzip']= "#{path}/gzip"
		break
	end
}

if $cfg['gzip'] == nil
	puts "Can't find the gzip in \$PATH !!"
	exit
end

Thread::abort_on_exception = true
load "#{$cfg['scriptRoot']}util2ch.rb"
CiPixRoot = "#{$cfg['scriptRoot']}pixmap/"
Zcat = "#{$cfg['gzip']} -d"

Color_DarkGreen = Gdk::Color.new(0,25700,0)
Color_DarkBlue = Gdk::Color.new(0,0,35723)
Color_Purple = Gdk::Color.new(32896,0,32896)
Color_Blue = Gdk::Color.new(0,0,65535)

RegexID = /^\d/
RegexFollowMany = /^(.*?)([>]+\s*\d+([\-*|,*]\d*)*)(.*)/e
RegexFollowOne = /^(.*?)([>]+\s*\d+)(.*)/e
RegexQuote = /^\s*[>]\s?.*/e
RegexUri = /^(.*?)(h?ttps?:[a-zA-Z0-9%&\?\/\;\:\@\&\=\+\$\,\-\_\.\!\~\*\'\\#]+)(.*)$/

case ARGV[0]
when '-v'
	puts "C.i. - Comapct Interface for 2ch. version #{CiVersion} (#{CiCode})"
	puts " Ruby: #{RUBY_VERSION} (#{RUBY_RELEASE_DATE})"
	puts " Gtk: #{Gtk::VERSION[0]}.#{Gtk::VERSION[1]}.#{Gtk::VERSION[2]}"
	puts " Ruby/Gtk: #{Gtk::BINDING_VERSION[0]}.#{Gtk::BINDING_VERSION[1]}#{Gtk::BINDING_VERSION[2]}"
	puts " PlatForm: #{RUBY_PLATFORM}"
	exit
when '-g'
	Util2ch.new.getBBSMenu unless $cfg['bbsMenuCheck']
end

class NodeData
	def initialize(uri)
		@uri = uri
	end

	def uri
		return(@uri)
	end
end

class Status
	def initialize
		@status = false
	end

	def toggleStatus
		if @status == true
			@status = false
		else
			@status = true
		end
		return(@status)
	end

	def active?
		@status
	end
end

module CiUtil
	def setTooltip(widget, text)
		tooltip = Gtk::Tooltips.new
		tooltip.set_tip(widget, text, nil)
	end

	def trunc(str)  # From goRua. Thanks.
		if  /^(.{1,#{$cfg['threadTabWidth']}}).*$/ =~ str
			return $1
		else
			return str
		end
	end
end

class CiPix
    def initialize(w)
		@w = w
		@close = [
			"10 9 2 1",
			"  c black",
			".       c None s None",
			"  ......  ",
			".  ....  .",
			"..  ..  ..",
			"...    ...",
			"....  ....",
			"...    ...",
			"..  ..  ..",
			".  ....  .",
			"  ......  "
		]
	end

	def getPixmap(name)
		if name == 'tabClose'
			pix, mask = Gdk::Pixmap.create_from_xpm_d(@w.window, nil, @close)
		else
			pix, mask = Gdk::Pixmap.create_from_xpm(@w.window, nil,
				"#{CiPixRoot}#{name}.xpm")
		end
		return(Gtk::Pixmap.new(pix, mask))
	end
end

class CiPost < Gtk::Window
	include PostMessage2ch
	include CiUtil

	def initialize(board, dat, title)
		@board = board
		@dat = dat

		super()
		self.set_default_size(400, 400)
		self.signal_connect('delete_event') { hide }
		
		nameLabel = Gtk::Label.new('Name')
		mailLabel = Gtk::Label.new('Mailto')

		@nameEntry = Gtk::Entry.new
		@mailEntry = Gtk::Entry.new

		labelBox = Gtk::VBox.new
		labelBox.pack_start nameLabel
		labelBox.pack_start mailLabel

		entryBox = Gtk::VBox.new
		entryBox.pack_start @nameEntry
		entryBox.pack_start @mailEntry

		entriesBox = Gtk::HBox.new
		entriesBox.pack_start labelBox, false
		entriesBox.pack_start entryBox, true

		sw = Gtk::ScrolledWindow.new
		sw.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
		@text = Gtk::Text.new.set_editable(true)
		sw.add @text

		postButton = Gtk::Button.new.add Pix.getPixmap('followup')
		setTooltip(postButton, 'Post message')
			postButton.signal_connect('clicked') {
				wrote, body = postMessage($bbsHash[@board], @board, @dat,
					@nameEntry.get_text, @mailEntry.get_text,
					@text.get_chars(0, @text.get_length))
				if wrote
					postInfoWrite(@nameEntry.get_text, @mailEntry.get_text,
						"#{Root}#{@board}/cache/#{@dat}.post")
					destroy
				else
					@status.set_text(body)
				end
			}
		cancelButton = Gtk::Button.new.add Pix.getPixmap('cancel')
		setTooltip(cancelButton, 'Close this window')
			cancelButton.signal_connect('clicked') { hide }
		aaButton = Gtk::MenuBar.new
		setTooltip(aaButton, 'Insert the Ascii Art')
			aaMenuRoot = Gtk::MenuItem.new.add Pix.getPixmap('aa')
			aaButton.append aaMenuRoot
			aaMenu = Gtk::Menu.new
			aaMenuRoot.set_submenu aaMenu
			aaList = getAAList
			aaList.each {|aa|
				label = Gtk::MenuItem.new(aa.chomp)
				aaMenu.append label
				label.signal_connect('activate') {
					@text.insert_text(aa.chomp, @text.position)
				}
			}

		blank = Gtk::Label.new('')

		buttonBox = Gtk::HBox.new
		buttonBox.pack_start postButton, false
		buttonBox.pack_start cancelButton, false
		buttonBox.pack_start blank, true
		buttonBox.pack_start aaButton, false

		@status = Gtk::Label.new('')

		postBox = Gtk::VBox.new
		postBox.pack_start buttonBox, false
		postBox.pack_start entriesBox, false
		postBox.pack_start sw, true
		postBox.pack_start @status, false

		self.set_title('Re: '+title)
		self.add postBox
	end

	def show_all(str = false, num = false)
		if str
			@text.insert nil, nil, nil, '>>'+num.to_s+"\n"
			str.each {|line| @text.insert nil, nil, nil, '>'+line }
			@text.insert nil, nil, nil, "\n"
			@text.position= @text.get_length
		end
		name, mailto = postInfoRead("#{Root}#{@board}/cache/#{@dat}.post")
		@nameEntry.set_text(name)
		@mailEntry.set_text(mailto)
		super()
	end
end

class TextFrame < Gtk::HBox
	include CiUtil

	def initialize(board, dat, title, url)
		super()
		@id = {'board' => board, 'dat' => dat, 'title' => title, 'url' => url }
		@bbsThread = BBSThread.new(board, dat)
			@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
			sb = Gtk::VScrollbar.new(@vadj)
			@text = Gtk::Text.new(nil, @vadj)
			@text.signal_connect('key_press_event'){|w, e|  # From goRua. Thanks.
				case e.keyval
				when Gdk::GDK_space
					tmp_vadj = @vadj.value + @vadj.page_size/1.1
					@vadj.set_value(tmp_vadj)
				when Gdk::GDK_BackSpace
					tmp_vadj = @vadj.value - @vadj.page_size/1.1
					@vadj.set_value(tmp_vadj)
				when Gdk::GDK_g
					@vadj.set_value(0)
				when Gdk::GDK_G
					@vadj.set_value(999999999)
				end
			}

			@text.signal_connect('button_press_event') {|w, e|
				case e.button
				when 5
					tmp_vadj = @vadj.value + @vadj.page_size/4
					@vadj.set_value(tmp_vadj)
				when 4
					tmp_vadj = @vadj.value - @vadj.page_size/4
					@vadj.set_value(tmp_vadj)
				#when 3
				#	if has_selection?
				#		target = getSelection
				#		target.gsub!(/[>]*/, '').strip!
				#		case target
				#		when /\d+/
				#			setTooltip(@text, getFollowUp(target))
				#		end
				#	end
				when 2
					if has_selection?
						target = getSelection
						if target =~ RegexUri
							target = $2
							target.gsub!(/^t+p/, 'http')
							system("#{$cfg['httpCommand'].sub('%d', target)}")
						end
					end
				end
			}

		self.pack_start @text
		self.pack_start sb, false
		get
		self
	end

	def get
		th = @bbsThread.getThread
		@text.freeze
		insertThread(th)
		@text.thaw
	end

	def update
		setVadjInfo
		@text.delete_text(0, @text.get_length)
		get
	end

	def getid
		return(@id)
	end

	def widget
		return(@text)
	end

	def adjust(value = false)
		value = getVadjInfo unless value
		@vadj.set_value(value)
	end

	def has_selection?
		@text.has_selection?
	end

	def getSelection(getnum = false)
		startSelection = @text.selection_start_pos
		endSelection = @text.selection_end_pos
		if startSelection > endSelection
			tmp = startSelection ; startSelection = endSelection ; endSelection = tmp
		end
		target = @text.get_chars(startSelection, endSelection).chomp
		if getnum
			num = ''
			tmptext = @text.get_chars(0, startSelection)
			tmptext.split("\n").reverse_each {|line|
				if line =~ /^(\d+):/
					num = $1
					break
				end
			}
			return([target, num])
		else
			return(target)
		end
	end

	def label
		if $cfg['closeOnTab']
			label = Gtk::Label.new("#{trunc(@id['title'])} ")
			@close = Gtk::Button.new.add Pix.getPixmap('tabClose')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @close
			box.show_all
			box
		else
			label = Gtk::Label.new(trunc(@id['title']))
		end
	end

	def labelButton
		@close
	end

	def getFollowUp(n)
		@bbsThread.getFollowUp(n.to_i)
	end

	def setVadjInfo
		fh = open("#{Root}#{@id['board']}/cache/#{@id['dat']}.info", 'w')
		fh.write @vadj.value.to_s
		fh.close
	end

	def getVadjInfo
		if File.exist?("#{Root}#{@id['board']}/cache/#{@id['dat']}.info")
			fh = open("#{Root}#{@id['board']}/cache/#{@id['dat']}.info")
			value = fh.read
			fh.close
			return(value.to_f)
		else
			return(0)
		end
	end

	def vadjInfo?
		File.exist?("#{Root}#{@id['board']}/cache/#{@id['dat']}.info")
	end

	def postOpen
		postBox = CiPost.new(@id['board'], @id['dat'], @id['title'])
		postBox.signal_connect('destroy') {
			update
			adjust(999999999)
		}
		if has_selection?
			target, num = getSelection(true)
			postBox.show_all(target, num)
		else
			postBox.show_all
		end
	end

	def finderOpen
		finder = ThreadFinder.new(@text)
		finder.show_all
	end

	def addBookmark
		@bbsThread.addBookmark
	end

	def deleteBookmark
		@bbsThread.deleteBookmark
	end

	def bookmark?
		@bbsThread.bookmark?
	end

	def abone?
		@bbsThread.abone?
	end

	def addUserAbone
		@bbsThread.addUserAbone(@id['title'])
	end

	def insertThread(stream)
		stream.each {|line|  # from goRua. Thanks.
			case line
			when RegexID  # ȯ
				@text.insert nil, Color_DarkGreen, nil,
					line.gsub("</b>",'').gsub("<b>",'') 
			when RegexFollowMany  # FollowUp
				@text.insert nil, nil, nil, $1
				@text.insert nil, Color_DarkBlue, nil, $2
				@text.insert nil, nil, nil, $4 + "\n"
			when RegexFollowOne  # FollowUp
				@text.insert nil, nil, nil, $1
				@text.insert nil, Color_DarkBlue, nil, $2
				@text.insert nil, nil, nil, $3 + "\n"
			when RegexQuote  # 
				@text.insert nil, Color_Purple, nil, line
			when RegexUri  # URL
				@text.insert nil, nil, nil, $1
				@text.insert nil, Color_Blue, nil, $2
				@text.insert nil, nil, nil, $3 + "\n"
			else
				@text.insert nil, nil, nil, line
			end
		}
	end
end

class ThreadFinder < Gtk::Window
	def initialize(textWidget)
		super()
		self.signal_connect('delete_event') { hide }
		self.set_title('Find in this Thread')

		findButton = Gtk::Button.new(' Find ')
			findButton.signal_connect('clicked') {
				pos = textWidget.position + 2
				str = textWidget.get_chars(0, textWidget.get_length)
				result = str.jindex(@finder.get_text, pos)

				if result
					textWidget.set_position(result)
					textWidget.select_region(result, result + @finder.get_text.jlength)
				end
			}
		cancelButton = Gtk::Button.new(' Cancel ')
			cancelButton.signal_connect('clicked') { hide }

		label = Gtk::Label.new(' Find text: ')
		@finder = Gtk::Entry.new
			@finder.signal_connect('activate') { findButton.clicked }

		findBox = Gtk::HBox.new
		findBox.pack_start label, false
		findBox.pack_start @finder

		buttons = Gtk::HBox.new
		buttons.pack_start findButton
		buttons.pack_start cancelButton

		mainBox = Gtk::VBox.new
		mainBox.pack_start findBox
		mainBox.pack_start buttons

		self.add mainBox
	end

	def show_all
		self.set_focus(@finder)
		super
	end
end

class RightMenu < Gtk::Menu
	def initialize(title)
		super()
		@title = Gtk::MenuItem.new(title)
		self.append @title
		self.append Gtk::MenuItem.new
		@bookmark = Gtk::MenuItem.new('add Bookmark')
		self.append @bookmark
		@abone = Gtk::MenuItem.new('Abone this Thread')
		self.append @abone

		self.show_all
	end

	def title
		@title
	end

	def bookmark
		@bookmark
	end

	def abone
		@abone
	end
end

class UrlView < Gtk::Entry
	def initialize
		super()
		self.set_editable(false)
	end
end

class Ci
	include Profile
	include BBSMenu
	include CiUtil
	include NetUp

	def initialize(widget)
		@top = widget
		@bbsmenu = parseBBSMenu
		@board = profileRead
		@bbsBoard = BBSBoard.new(@board)
		@title = ''
		@dat = ''
		@updateFilter = Status.new
		@bookmarkFilter = Status.new
		@freeze = Status.new
		getBBSMenu if $cfg['bbsMenuCheck']
		@threadChain = {}
		@getThread = Thread.fork { Thread.exit }
	end

	def exitCi
		session = ''
		@mainNote.set_page(0)
		@mainNote.next_page
		while @mainNote.get_current_page != 0
			session << @mainNote.cur_page.child.getid['board']+' '
			session << @mainNote.cur_page.child.getid['dat']+' '
			session << @mainNote.cur_page.child.getid['title']+"\n"
			@mainNote.cur_page.child.setVadjInfo
			@threadChain.delete(@mainNote.cur_page.child.getid['dat'])
			@mainNote.remove_page(@mainNote.get_current_page)
			@mainNote.next_page
		end
		fh = open("#{Root}session", 'w')
		fh.write session
		fh.close
		profileWrite(@board)
	end

	def onFreeze
		unless @freeze.active?
			@pgBar.set_activity_mode(true)
			@pgactive = Gtk::timeout_add(100) { @pgBar.update(rand) ; true }
			@statusBar.push(@id, ' Now Loading.....')
			@freeze.toggleStatus
		end
	end

	def offFreeze
		if @freeze.active?
			Gtk.timeout_remove(@pgactive)
			@statusBar.pop(@id)
			@pgBar.set_activity_mode(false)
			@pgBar.update(0)
			@freeze.toggleStatus
		end
	end

	def underBar
		box = Gtk::HBox.new
			@statusBar = Gtk::Statusbar.new
			@id = @statusBar.get_context_id('C.i. Status')
			@pgBar = Gtk::ProgressBar.new
			#@pgBar.set_activity_mode true
			#@pgBar.set_activity_step 2
			#@pgBar.set_activity_blocks 1000
		box.pack_start @statusBar
		box.pack_start @pgBar, false
		return(box)
	end

	def boardSelecter  # CTree褫CListCListΤۤå票⡣
		sw = Gtk::ScrolledWindow.new
			sw.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)

		@boardTree = Gtk::CTree.new(["Board Name"], 0)
		@boardTree.set_line_style(Gtk::CTree::LINES_DOTTED)
			root = @boardTree.insert_node(nil, nil, ["The 2ch Boards"], 1,
				nil, nil, nil, nil, false, true)
			nodes = @bbsmenu 
			nodes.each {|info|
				if info[1] == 'C-'
					@semiRoot = @boardTree.insert_node(root, nil, [info[0]], 1,
						nil, nil, nil, nil, false, false)
				else
					node = @boardTree.insert_node(@semiRoot, nil, [info[0]], 1,
						nil, nil, nil, nil, true, false)
					@boardTree.node_set_row_data(node, NodeData.new(info[1]))
				end
			}

			@boardTree.signal_connect('tree_select_row') {|t, node, c|
				if @boardTree.get_node_info(node)[6]
					server, board = parseUri(@boardTree.node_get_row_data(node).uri)
					switchBoard(board)
					subjectFrameUpdate(false)
				end
			}
		sw.add @boardTree
		return(sw)
	end

	def topButtons
		buttons = Gtk::HBox.new
		select = Gtk::ToggleButton.new.add Pix.getPixmap('boardselect')
			setTooltip(select, 'Board Selecter Open/Close')
			select.signal_connect('clicked') {
				if select.active?
					@mainPane.set_position(BSActive) 
				else
					@mainPane.set_position(BSNonActive)
				end
			}
		bookmark = Gtk::ToggleButton.new.add Pix.getPixmap('bookmark')
			setTooltip(bookmark, 'BookMark Open/Close')
			bookmark.signal_connect('clicked') {
				if bookmark.active?
					subjectFrameUpdate(false, false, true)
				else
					subjectFrameUpdate(false)
				end
			}
		reload = Gtk::Button.new.add Pix.getPixmap('refresh_blue')
			setTooltip(reload, 'Reload Subjects')
			reload.signal_connect('clicked') { subjectFrameUpdate }
		cancel = Gtk::Button.new.add Pix.getPixmap('cancel')
			setTooltip(cancel, 'Stop')
			cancel.signal_connect('clicked') { stopSubjectUpdate }
		find = Gtk::ToggleButton.new.add Pix.getPixmap('search')
			setTooltip(find, 'Thread Search')
			find.signal_connect('clicked') {
				if find.active?
					@topNote.set_page(1)
				else
					subjectFrameUpdate(false)
				end
			}
		exit = Gtk::Button.new.add Pix.getPixmap('exit')
			setTooltip(exit, 'Exit')
			exit.signal_connect('clicked') { exitCi ; Gtk::main_quit }
		@urlview = UrlView.new
		# @urlview.set_text('How many files(0-15) ?')
		# @urlview.set_text('MEMORY 640KB + 13312KB OK')
		@urlview.set_text('Welcome to C.i. World !!')
		if $cfg['netUpCi']
		 	result, body = netUp
		 	@urlview.set_text(body.chomp) if result
		end
		# go = Gtk::Button.new(' Go !! ')

		buttons.pack_start select, false
		buttons.pack_start bookmark, false
		buttons.pack_start reload, false
		buttons.pack_start cancel, false
		buttons.pack_start find, false
		buttons.pack_start exit, false
		buttons.pack_start @urlview, true
		# buttons.pack_start go, false
		return(buttons)
	end

	def finder
		@findEntry = Gtk::Entry.new
		@findEntry.set_editable(true)
			@findEntry.signal_connect('activate') { subjectFrameUpdate(false, true) }
		findButton = Gtk::Button.new(' Find ')
			findButton.signal_connect('clicked') { subjectFrameUpdate(false, true) }
		closeButton = Gtk::Button.new(' Close ')
			closeButton.signal_connect('clicked') {
				@findEntry.delete_text(0, @findEntry.get_text.length)
				subjectFrameUpdate(false)
				@topNote.set_page(0)
			}

		box = Gtk::HBox.new
		box.pack_start @findEntry, true
		box.pack_start findButton, false
		box.pack_start closeButton, false
		return(box)
	end

	def threadButtons
		buttons = Gtk::HBox.new
		@bookmarkButton = Gtk::CheckButton.new
		@bookmarkButton.signal_connect('toggled') {|w|
			unless @switch
				if @mainNote.cur_page.child.bookmark?
					@mainNote.cur_page.child.deleteBookmark
				else
					@mainNote.cur_page.child.addBookmark
				end
			end
		}
		exit = Gtk::Button.new.add Pix.getPixmap('exit')
		setTooltip(exit, 'Exit')
		exit.signal_connect('clicked') { exitCi ; Gtk::main_quit }
		@threadUrl = UrlView.new
		closeButton = Gtk::Button.new.add Pix.getPixmap('cancel')
		setTooltip(closeButton, 'Close this thread')
		closeButton.signal_connect('clicked') {
			@mainNote.cur_page.child.setVadjInfo
			@threadChain.delete(@mainNote.cur_page.child.getid['dat'])
			@mainNote.remove_page(@mainNote.get_current_page)
			switchNote
		}
		reloadButton = Gtk::Button.new.add Pix.getPixmap('refresh_green')
		setTooltip(reloadButton, 'Reload')
		reloadButton.signal_connect('clicked') {
			@mainNote.cur_page.child.update
			@mainNote.cur_page.child.adjust
		}
		followupButton = Gtk::Button.new.add Pix.getPixmap('edit')
		setTooltip(followupButton, 'Follow Up')
		followupButton.signal_connect('clicked') {
			@mainNote.cur_page.child.postOpen
		}
		searchButton = Gtk::Button.new.add Pix.getPixmap('search')
		setTooltip(searchButton, 'Find in this Thread.')
		searchButton.signal_connect('clicked') {
			@mainNote.cur_page.child.finderOpen
		}
		webBrowseButton = Gtk::Button.new.add Pix.getPixmap('extwww')
		setTooltip(webBrowseButton, 'Go to the Selected URI by Ext. Browser.')
		webBrowseButton.signal_connect('clicked') {
			if @mainNote.cur_page.child.has_selection?
				target = @mainNote.cur_page.child.getSelection
				if target =~ RegexUri
					target = $2
					target.gsub!(/^t+p/, 'http')
					system("#{$cfg['httpCommand'].sub('%d', target)}")
				end
			end
		}

		followSearch = Gtk::Button.new.add Pix.getPixmap('followsearch')
		followSearch.signal_connect('clicked') {
			if @mainNote.cur_page.child.has_selection?
				target = @mainNote.cur_page.child.getSelection
				target.gsub!(/[>]*/, '').strip!
				case target
				when /\d+/
					setTooltip(followSearch,
						@mainNote.cur_page.child.getFollowUp(target))
				end
			end
		}

		deleteButton = Gtk::Button.new.add Pix.getPixmap('cancel2')
		setTooltip(deleteButton, 'Abone this thread')
		deleteButton.signal_connect('clicked') {
			@mainNote.cur_page.child.addUserAbone
		}
				
		buttons.pack_start exit, false
		buttons.pack_start @threadUrl, true
		buttons.pack_start @bookmarkButton, false
		buttons.pack_start closeButton, false
		buttons.pack_start reloadButton, false
		buttons.pack_start followupButton, false
		buttons.pack_start searchButton, false
		buttons.pack_start followSearch, false
		buttons.pack_start webBrowseButton, false
		buttons.pack_start deleteButton, false

		return(buttons)
	end

	def topNote
		@topNote = Gtk::Notebook.new
			@topNote.set_show_tabs(false)
			@topNote.append_page(topButtons, Gtk::Label.new('Main'))
			@topNote.append_page(finder, Gtk::Label.new('Finder'))
			@topNote.append_page(threadButtons, Gtk::Label.new('Thread'))
		return(@topNote)
	end

	def mainNote
		subjectBox = Gtk::VBox.new
			subjectBox.pack_start subjectFrame
			subjectBox.pack_start underBar, false

		@mainNote = Gtk::Notebook.new
			@mainNote.set_scrollable(true)
			@mainNote.append_page(subjectBox,
				Gtk::Label.new("#{@board.capitalize}@2ch"))

		@mainNote.signal_connect('button_release_event') {
			switchNote
		}

		# get session
		if File.exist?("#{Root}session")
			fh = open("#{Root}session")
				session = fh.read
				fh.close
			session.each {|line|
				a = line.split(' ')
				board = a.shift
				dat = a.shift
				title = a.join(' ')
				textFrameThreadGet(board, title, dat, false)
			}
		end

		return(@mainNote)
	end

	def switchNote
		@switch = true
		cur = @mainNote.cur_page.child
			if @mainNote.get_current_page == 0
				@top.set_title("C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})")
				@urlview.set_text("http://#{$bbsHash[@board]}/#{@board}/")
				@mainNote.set_tab_label_text(cur, "#{@board.capitalize}@2ch")
				@topNote.set_page(0)
			else
				title = cur.getid['title']
				url = cur.getid['url']
				@threadUrl.set_text(url)
				if cur.bookmark?
					@bookmarkButton.active = true
				else
					@bookmarkButton.active = false
				end
				@top.set_title("#{title} - C.i. (version: #{CiVersion})")
				@topNote.set_page(2)
			end
		@switch = false
	end

	def mainPane
		@mainPane = Gtk::HPaned.new
		case $cfg['boardSelect']
		when 'right'
			@mainPane.pack1(mainNote, true, true)
			@mainPane.pack2(boardSelecter, false, true)
		else
			@mainPane.pack1(boardSelecter, false, true)
			@mainPane.pack2(mainNote, true, true)
		end
		@mainPane.set_gutter_size(2)
		@mainPane.set_handle_size(2)
		@mainPane.set_position(BSNonActive)
		return(@mainPane)
	end

	def subjectFrame
		sw = Gtk::ScrolledWindow.new
		sw.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
		sw.set_usize(200, 200)
		@subjects = Gtk::CList.new(['', 'S', 'C', '', 'F', 'C', 'subject'])
		(0..5).each {|x|
			@subjects.set_column_justification(x, Gtk::JUSTIFY_RIGHT)
			@subjects.set_column_auto_resize(x, true)
		}
		@subjects.set_column_justification(6, Gtk::JUSTIFY_LEFT)
		@subjects.set_column_auto_resize(6, true)
		@subjects.set_column_min_width(4, 30)
		@subjects.set_column_min_width(5, 30)
		@threadHash = {}

		@subjects.signal_connect('select_row') {|w, r, c, e|
			case c
			when 0
				menu = RightMenu.new(@subjects.get_text(r, 6))
				if @bbsBoard.bookmark?(@threadHash[@subjects.get_text(r, 0)])
					menu.bookmark.child.set_text('Delete Bookmark')
				else
					menu.bookmark.child.set_text('Add Bookmark')
				end
				menu.title.signal_connect('activate') {
					@subjects.unselect_all
				}
				menu.bookmark.signal_connect('activate') {
					if @bbsBoard.bookmark?(@threadHash[@subjects.get_text(r, 0)])
						@bbsBoard.deleteBookmark(@threadHash[@subjects.get_text(r, 0)])
					else
						@bbsBoard.addBookmark(@threadHash[@subjects.get_text(r, 0)])
					end
					@subjects.unselect_all
				}
				menu.abone.signal_connect('activate') {
					@bbsBoard.addUserAbone(@threadHash[@subjects.get_text(r, 0)],
						@subjects.get_text(r, 6))
					@subjects.unselect_all
				}
				menu.popup(nil, nil, nil, e.button, e.time)
			else
				textFrameThreadGet(@board, @subjects.get_text(r, 6),
					@threadHash[@subjects.get_text(r, 0)])
			end
		}

		@subjects.signal_connect('click_column') {|w, c|
			case c
			when 1
				onFreeze
				@subjects.clear
				if @updateFilter.toggleStatus
					h = @bbsBoard.getSubjects(false, false, true)
				else
					h = @bbsBoard.getSubjects(false, false, false)
				end
				@subjects.freeze
				@threadHash.clear
				n = 0
				h.each {|th|
					n += 1
					@subjects.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
					@threadHash[n.to_s]= th[3]
				}
				@subjects.thaw
				offFreeze
			end
		}

		h = @bbsBoard.getSubjects
		@subjects.freeze
		@threadHash.clear
		n = 0
		h.each {|th|
			n += 1
			@subjects.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
			@threadHash[n.to_s]= th[3]
		}
		@subjects.thaw

		sw.add @subjects
		return(sw)
	end

	def switchBoard(board)
		@board = board
		@bbsBoard = ''
		@bbsBoard = BBSBoard.new(board)
		@urlview.set_text("http://#{$bbsHash[@board]}/#{@board}/")
		@mainNote.set_tab_label_text(@mainNote.cur_page.child,
			"#{@board.capitalize}@2ch")
	end

	def subjectFrameUpdate(get = true, search = false, bookmark = false)
		@getThread = Thread.fork {
			if search
				a = @bbsBoard.getSubjects(false, @findEntry.get_text)
			elsif bookmark
				a = @bbsBoard.getSubjects(false, false, false, true)
			else
				a = @bbsBoard.getSubjects(get)
			end
			@subjects.clear
			@subjects.freeze
			@threadHash.clear
			n = 0
			a.each {|th|
				n += 1
				@subjects.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
				@threadHash[n.to_s]= th[3]
			}
			@subjects.thaw
			offFreeze
		}
		onFreeze
		@urlview.set_text("http://#{$bbsHash[@board]}/#{@board}/")
	end

	def stopSubjectUpdate
		@getThread.kill if @getThread.alive?
		offFreeze
		@subjects.unselect_all
	end

	def textFrameThreadGet(board, title, dat, focus = true)
		@dat = ''
		@title = title.chomp ; @dat = dat
		onFreeze
		@getThread = Thread.fork {
			if @threadChain.include?(dat)
				@mainNote.next_page
				while @mainNote.cur_page.child.getid['dat'] != dat
					@mainNote.next_page
				end
				@mainNote.cur_page.child.update
			else
				uri = "http://#{$bbsHash[board]}/test/read.cgi/#{board}/#{dat.sub(/\.dat/, '/')}"
				texts = TextFrame.new(board, dat, title.chomp, uri)
				@threadChain[dat]= texts
				titleLabel = texts.label
				if $cfg['closeOnTab']
					texts.labelButton.signal_connect('clicked'){
						tmp = 0
						texts.setVadjInfo
						@threadChain.delete(texts.getid['dat'])
						if @mainNote.cur_page.child == texts
							@mainNote.remove_page(@mainNote.get_current_page)
							switchNote
							break
						elsif @mainNote.get_current_page != 0
							tmp = @mainNote.cur_page.child.getid['dat']
						end
						@mainNote.set_page(0)
						@mainNote.next_page
						while @mainNote.cur_page.child.getid['dat'] != texts.getid['dat']
							@mainNote.next_page
						end
						@mainNote.remove_page(@mainNote.get_current_page)
						@mainNote.set_page(0)
						@mainNote.next_page
						if tmp == 0 or @mainNote.get_current_page == 0
							@mainNote.set_page(0)
							switchNote
							break
						end
						while @mainNote.cur_page.child.getid['dat'] != tmp
							@mainNote.next_page
						end
						switchNote
					}
				end
				@mainNote.append_page(texts, titleLabel)
				@mainNote.show_all
				texts.adjust
				if focus
					@mainNote.next_page
					while @mainNote.cur_page.child.getid['dat'] != dat
						@mainNote.next_page
					end
				end
			end
			setThreadCached
			@subjects.unselect_all
			@top.set_focus(@mainNote.cur_page.child.widget) if focus
			@topNote.set_page(2)
			switchNote
			offFreeze
		}
	end

	def setThreadCached
		@subjects.each_selection {|r|
			@subjects.set_text(r, 2, 'C')
			@subjects.set_text(r, 3, '=')
			@subjects.set_text(r, 5, @subjects.get_text(r, 4))
			@bbsBoard.cachedThreadSave(@threadHash[@subjects.get_text(r, 0)])
		}
	end
end

gtkrc = Root + 'gtkrc'
Gtk::RC.parse(gtkrc) if File.exist?(gtkrc)

w = Gtk::Window.new
w.set_default_size($cfg['defaultWidth'], $cfg['defaultHeight'])
w.set_title("C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})")
# w.show_all
w.realize
Pix = CiPix.new(w)
ci = Ci.new(w)

# set main pane value
#

case $cfg['boardSelect']
when 'right'
	BSActive = $cfg['boardSelectorWidth']
	BSNonActive = 5000
else
	BSActive = $cfg['defaultWidth'] - $cfg['boardSelectorWidth']
	BSNonActive = 0
end

main = Gtk::VBox.new
main.pack_start ci.topNote, false
main.pack_start ci.mainPane

w.signal_connect('delete_event') { ci.exitCi ; Gtk::main_quit }
w.add main
w.show_all
Gtk.main
